*End-of-line comments
$oneolcom
*In-line comments
$oninline
*Allow empty data sets and parameters
$onempty

$ontext
This program modifies and balances any regional 2008 IMPLAN Social Acounting
Matrix (SAM) to include detailed land-use data. The program also separates
IMPLAN's proprietors income account into the more intuitive factors of
production of labor and capital. Import duties are also separated from
IMPLAN's aggregated indirect business tax (IBT). IMPLAN's IBT account is
also modified for the wholesale and retail trade sectors to reflect more
accurate tax allocation.

The sambuild1.gms program is roughly based on original code written by
Rutherford (1996) and Gilbert (2001) and subsequently modified by Stodick
(2004). The original GAMS code documents have been made publicly-available
by the School of Economic Sciences at Washington State University at:
http://www.agribusiness-mgmt.wsu.edu/Holland_model/original-regional-model.htm

The current version of the program has been heavily modified by Juan J. Monge
at Texas A&M University (2010). The following series of programs will run
under GAMS for LINUX.
$offtext

!!PATH is the folder where the 26 data files created by IMPLAN are located and
!!where the SAM.gdx file will be saved.			                              
$SETGLOBAL PATH /home/jmonge/landuse/model/east/

!!The set REGION is helpful to identify the regional aggregation
SET REGION /east/;

!!Set this global variable to "YES" if the aggregation includes all the
!!48 contiguous states in the U.S. Else set it to "NO"
$SETGLOBAL NATIONAL NO

!!SETS
	!!This is the set of all 440 IMPLAN activities and commodities
    	SET Y IMPLAN codes for the entire set of activities and commodities /
    	!! Activities
    		1*440
    	!! Commodities
    		3001*3440
    	/;
    	
    !!This is the set of all the 48 contiguous states included in the study
    SET STATE U.S. States /
    	1 Alabama
    	4 Arizona
    	5 Arkansas
    	6 California
    	8 Colorado
    	9 Connecticut
    	10 Delaware
    	12 Florida
    	13 Georgia
    	16 Idaho
    	17 Illinois
    	18 Indiana
    	19 Iowa
    	20 Kansas
    	21 Kentucky
    	22 Louisiana
    	23 Maine
    	24 Maryland
    	25 Massachusetts
    	26 Michigan
    	27 Minnesota
    	28 Mississippi
    	29 Missouri
    	30 Montana
    	31 Nebraska
    	32 Nevada
    	33 New Hampshire
    	34 New Jersey
    	35 New Mexico
    	36 New York
    	37 North Carolina
    	38 North Dakota
    	39 Ohio
    	40 Oklahoma
    	41 Oregon
    	42 Pennsylvania
    	44 Rhode Island
    	45 South Carolina
    	46 South Dakota
    	47 Tennessee
    	48 Texas
    	49 Utah
    	50 Vermont
    	51 Virginia
    	53 Washington
    	54 West Virginia
    	55 Wisconsin
    	56 Wyoming/;
    
    !!IMPORTANT:
    !!Include the states that are included in the IMPLAN SAM regional aggregation
	SET AGG(STATE) Arbitrary Regional Aggregation (Follow from IMPLAN) /
		33,23,25,9,34,10,24,42,50,44,36,47,54,51,21,37,1,13,12,45,5,22,28,19,29,17,18,39,55,26,27,40,48,20,31,46,38,8 !! East
    	!!6,41,53 !!Pacific
    	!!30,16,56,32,49,8,4,35 !!Mountain
        !!20,31,46,38 !!Northern Plains
        !!40,48 !!Southern Plains
        !!55,26,27 !!Lake States
        !!19,29,17,18,39 !!Corn Belt
        !!5,22,28 !!Delta States
        !!1,13,12,45 !!Southeast
        !!47,54,51,21,37 !!Appalachia
    	!!33,23,25,9,34,10,24,42,50,44,36 !!Northeast
    	/;
    
    !!Creating the set for the rows and columns of the IMPLAN SAM and reflecting
	!!the activity and commodity aggregation imported from IMPLAN
    	SET K IMPLAN codes for the rows and columns of the IMPLAN SAM /
    	!!Activities
    		1		A-Oilseed           	
    	    2	    A-Grain
    	    3	    A-Other Agriculture
    	    7	    A-Tobacco
    	    8	    A-Cotton
    	    9	    A-Sugar
    	    10	    A-Other Crop
    	    11	    A-Cattle Ranch
    	    12	    A-Dairy
    	    16	    A-Forestry
    	    20	    A-Mining
    	    31	    A-Utilities
    	    34	    A-Construction
    	    41	    A-Manufacturing
    	    319	    A-Wholesale
    	    320	    A-Retail
    	    332	    A-Transp & Ware
    	    341	    A-Information
    	    354	    A-Finance
    	    360	    A-Land Rent
    	    361	    A-Other Rent
    	    367	    A-Prof Sci Tech Serv
    	    381	    A-Management
    	    382	    A-Admin & Waste Serv
    	    391	    A-Education
    	    394	    A-Health
    	    402	    A-Recreation
    	    411	    A-Accom & Food Serv
    	    414	    A-Other Serv
    	    427	    A-Government
    	    433		A-Unclassified
    	    437		A-Gov Emp & Payroll	
    	!!Commodities
    		3001	C-Oilseed              	                                   	
    	    3002	C-Grain                
    	    3003	C-Other Agriculture            
    	    3007	C-Tobacco              
    	    3008	C-Cotton               
    	    3009	C-Sugar                
    	    3010	C-Other Crop           
    	    3011	C-Cattle Ranch         
    	    3012	C-Dairy                
    	    3016	C-Forestry             
    	    3020	C-Mining               
    	    3031	C-Utilities            
    	    3034	C-Construction         
    	    3041	C-Manufacturing        
    	    3319	C-Wholesale            
    	    3320	C-Retail               
    	    3332	C-Transp & Ware        
    	    3341	C-Information          
    	    3354	C-Finance              
    	    3360	C-Land Rent            
    	    3361	C-Other Rent           
    	    3367	C-Prof Sci Tech Serv
    	    3381	C-Management           
    	    3382	C-Admin & Waste Serv   
    	    3391	C-Education            
    	    3394	C-Health               
    	    3402	C-Recreation           
    	    3411	C-Accom & Food Serv    
    	    3414	C-Other Serv           
    	    3427	C-Government           
    		3433	C-Unclassified      
    	    3437	C-Gov Emp & Payroll
    	!!Factors
    		5001	Labor
    		6001	Proprietary Income
    		7001	Capital
    		8001	Indirect Business Taxes
    	!!Institutions
    		10001	Household 1                	
    	    10002	Household 2
    	    10003	Household 3
    	    10004	Household 4
    	    10005   Household 5
    	    10006   Household 6
    	    10007	Household 7
    	    10008   Household 8
    	    10009   Household 9
    	    11001   Fed Gov Non-Defense
    	    11002   Fed Gov Defense
    	    11003   Fed Gov Investment
    	    12001	State Gov Non-Education
    	    12002   State Gov Education
    	    12003   State Gov Investment
    	    13001   Enterprises
    	    14001   Gross Priv Fixed Investment
    		14002   Inventory Sales Deletions
    	!!Trade Regions
    		25001	Trade with the rest of the world
    		28001	Trade with the rest of the US
    	!!Major Land Resource Areas
			MLRA001
            MLRA002
            MLRA003
            MLRA005
            MLRA006
            MLRA007
            MLRA008
            MLRA009
            MLRA010
            MLRA011
            MLRA012
            MLRA014
            MLRA017
            MLRA018
            MLRA019
            MLRA020
            MLRA022
            MLRA023
            MLRA024
            MLRA025
            MLRA026
            MLRA028
            MLRA029
            MLRA030
            MLRA031
            MLRA032
            MLRA033
            MLRA034
            MLRA035
            MLRA036
            MLRA037
            MLRA038
            MLRA039
            MLRA040
            MLRA043
            MLRA044
            MLRA045
            MLRA046
            MLRA050
            MLRA051
            MLRA052
            MLRA053
            MLRA054
            MLRA059
            MLRA060
            MLRA061
            MLRA062
            MLRA063
            MLRA064
            MLRA065
            MLRA066
            MLRA067
            MLRA070
            MLRA071
            MLRA072
            MLRA073
            MLRA074
            MLRA075
            MLRA076
            MLRA077
            MLRA078
            MLRA079
            MLRA080
            MLRA081
            MLRA082
            MLRA083
            MLRA084
            MLRA085
            MLRA086
            MLRA088
            MLRA089
            MLRA090
            MLRA091
            MLRA092
            MLRA093
            MLRA095
            MLRA096
            MLRA097
            MLRA099
            MLRA100
            MLRA101
            MLRA104
            MLRA105
            MLRA106
            MLRA107
            MLRA108
            MLRA109
            MLRA111
            MLRA112
            MLRA113
            MLRA114
            MLRA115
            MLRA117
            MLRA118
            MLRA119
            MLRA121
            MLRA122
            MLRA123
            MLRA125
            MLRA126
            MLRA127
            MLRA130
            MLRA132
            MLRA133
            MLRA134
            MLRA135
            MLRA136
            MLRA137
            MLRA138
            MLRA140
            MLRA144
            MLRA145
            MLRA147
            MLRA148
            MLRA149
            MLRA150
            MLRA152
            MLRA153
            MLRA155
            MLRA156
            MLRA157
            MLRA159
            MLRA160
            MLRA161
            MLRA162
            MLRA163
            MLRA164
            MLRA165
            MLRA166
            MLRA167
            MLRA168
            MLRA169
            MLRA170
            MLRA172
            MLRA173
            MLRA174
            MLRA175
            MLRA176
            MLRA177
            MLRA178
            MLRA179
            MLRA181
            MLRA182
            MLRA184
            MLRA185
            MLRA186
            MLRA187
            MLRA188
            MLRA189
            MLRA191
            MLRA192
            MLRA193
            MLRA194
            MLRA195
            MLRA196
            MLRA197
            MLRA199
            MLRA200
            MLRA202
            MLRA203
            MLRA204
            MLRA205
            MLRA206
            MLRA207
            MLRA208
            MLRA210
            MLRA211
            MLRA212
            MLRA214
            MLRA215
            MLRA216
            MLRA217
            MLRA218
            MLRA219
            MLRA220
            MLRA221
            MLRA222
            MLRA223
            MLRA224
            MLRA225
            MLRA227
            MLRA228
            MLRA230
            MLRA231
            MLRA232
            MLRA233
            MLRA234
            MLRA235
            MLRA236
            MLRA238
            MLRA239
            MLRA240
            MLRA241
            MLRA242
            MLRA243
            MLRA244
            MLRA246
            MLRA247
            MLRA248
            MLRA249
            MLRA250
            MLRA252
            MLRA253
            MLRA254
            MLRA255
            MLRA256
            MLRA257
            MLRA258
            MLRA259
            MLRA260
            MLRA261
            MLRA262
            MLRA263
            MLRA264
            MLRA265
            MLRA266
            MLRA267
    	!!Taxes		
    		IMPTAX	Import taxes
    	!!Check Parameters
    		TOTAL
    		DIFF
    	/;
    
    	SET IMPLAN(K,Y) mapping the aggregated activities and commodities to the entire set of 440 IMPLAN sectors /
    	!!Activities
    		1  .(1					)	A-Oilseed           
    	    2  .(2					)	A-Grain
    	    3  .(3*6,13*15,17*19	)	A-Other Agriculture
    	    7  .(7					)	A-Tobacco
    	    8  .(8					)	A-Cotton
    	    9  .(9					)	A-Sugar
    	    10 .(10					)	A-Other Crop
    	    11 .(11					)	A-Cattle Ranch
    	    12 .(12					)	A-Dairy
    	    16 .(16					)	A-Forestry
    	    20 .(20*30				)	A-Mining
    	    31 .(31*33				)	A-Utilities
    	    34 .(34*40				)	A-Construction
    	    41 .(41*318				)	A-Manufacturing
    	    319.(319				)	A-Wholesale
    	    320.(320*331			)	A-Retail
    	    332.(332*340			)	A-Transp & Ware
    	    341.(341*353			)	A-Information
    	    354.(354*359			)	A-Finance
    	    360.(360				)	A-Land Rent
    	    361.(361*366			)	A-Other Rent
    	    367.(367*380			)	A-Prof Sci Tech Serv
    	    381.(381				)	A-Management
    	    382.(382*390			)	A-Admin & Waste Serv
    	    391.(391*393			)	A-Education
    	    394.(394*401			)	A-Health
    	    402.(402*410			)	A-Recreation
    	    411.(411*413			)	A-Accom & Food Serv
    	    414.(414*426			)	A-Other Serv
    	    427.(427*432			)	A-Government
    	    433.(433*436			)	A-Unclassified
    	    437.(437*440			)	A-Gov Emp & Payroll	
    	!!Commodities
    		3001.(3001							)	C-Oilseed           
    	    3002.(3002				            )	C-Grain
    	    3003.(3003*3006,3013*3015,3017*3019 )	C-Other Agriculture
    	    3007.(3007				            )	C-Tobacco
    	    3008.(3008				            )	C-Cotton
    	    3009.(3009				            )	C-Sugar
    	    3010.(3010				            )	C-Other Crop
    	    3011.(3011				            )	C-Cattle Ranch
    	    3012.(3012				            )	C-Dairy
    	    3016.(3016				            )	C-Forestry
    	    3020.(3020*3030			            )	C-Mining
    	    3031.(3031*3033			            )	C-Utilities
    	    3034.(3034*3040			            )	C-Construction
    	    3041.(3041*3318			            )	C-Manufacturing
    	    3319.(3319			                )	C-Wholesale
    	    3320.(3320*3331		                )	C-Retail
    	    3332.(3332*3340		                )	C-Transp & Ware
    	    3341.(3341*3353		                )	C-Information
    	    3354.(3354*3359		                )	C-Finance
    	    3360.(3360			                )	C-Land Rent
    	    3361.(3361*3366		                )	C-Other Rent
    	    3367.(3367*3380		                )	C-Prof Sci Tech Serv
    	    3381.(3381			                )	C-Management
    	    3382.(3382*3390		                )	C-Admin & Waste Serv
    	    3391.(3391*3393		                )	C-Education
    	    3394.(3394*3401		                )	C-Health
    	    3402.(3402*3410		                )	C-Recreation
    	    3411.(3411*3413		                )	C-Accom & Food Serv
    	    3414.(3414*3426		                )	C-Other Serv
    	    3427.(3427*3432		                )	C-Government
    		3433.(3433*3436		                )	C-Unclassified
    	    3437.(3437*3440		                )	C-Gov Emp & Payroll	
    	/;
    
    	SET Z IMPLAN abbreviations for the rows and columns in the extended SAM /
    	!!Activities
    		Aolsd	!!Oilseed farming                                                 	          	
    	    Agran	!!Grain farming
    	    Aoagr	!!Other Agriculture
    	    Atobc	!!Tobacco farming            			
    	    Acott   !!Cotton farming
    	    Asugr   !!Sugarcane and sugar beet farming
    	    Aocrp   !!All other crop farming
    	    Acatt   !!Cattle ranching and farming
    	    Adair   !!Dairy cattle and milk production
    	    Afors   !!Forestry nurseries, forest products, and timber tracts
    	    Amini   !!Mining
    	    Autil   !!Utilities
    	    Acons   !!Construction
    	    Amanf   !!Manufacturing
    	    Awhol   !!Wholesale trade
    	    Aretl   !!Retail trade
    	    Atrns   !!Transportation & Warehousing
    	    Ainfo   !!Information
    	    Afinc   !!Financial services
    	    Aland   !!Real estate
    	    Aornt   !!Other property rent
    	    Aprof   !!Professional, scientific and technical services
    	    Amgmt   !!Management of companies and enterprises
    	    Aadmw   !!Administrative & waste services
    	    Aeduc   !!Education services
    	    Ahlth   !!Health services
    	    Aentt   !!Amusement and recreational services
    	    Ahotl   !!Accomodation & food services
    	    Aoser   !!Other services
    	    Agven   !!Government utilities and enterprises
    	    Auncl   !!Unclassified
    	    Agvem   !!Government employment & payroll
    	!!Commodities
    	    Colsd	!!Oilseed farming                                                 	
    	    Cgran   !!Grain farming
    	    Coagr   !!Other agriculture
    	    Ctobc	!!Tobacco farming            			
    	    Ccott   !!Cotton farming
    	    Csugr   !!Sugarcane and sugar beet farming
    	    Cocrp   !!All other crop farming
    	    Ccatt   !!Cattle ranching and farming
    	    Cdair   !!Dairy cattle and milk production
    	    Cfors   !!Forestry nurseries, forest products, and timber tracts
    	    Cmini   !!Mining
    	    Cutil   !!Utilities
    	    Ccons   !!Construction
    	    Cmanf   !!Manufacturing
    	    Cwhol   !!Wholesale trade
    	    Cretl   !!Retail trade
    	    Ctrns   !!Transportation & Warehousing
    	    Cinfo   !!Information
    	    Cfinc   !!Financial services
    	    Cland   !!Real estate
    	    Cornt    !!Other property rent
    	    Cprof   !!Professional, scientific and technical services
    	    Cmgmt   !!Management of companies and enterprises
    	    Cadmw   !!Administrative & waste services
    	    Ceduc   !!Education services
    	    Chlth   !!Health services
    	    Centt   !!Amusement and recreational services
    	    Chotl   !!Accomodation & food services
    	    Coser   !!Other services
    	    Cgven   !!Government utilities and enterprises
    	    Cuncl   !!Unclassified
    	    Cgvem   !!Government employment & payroll	
    	!!Factors
    	    LABOR		!!Labor
    	    PROPINC		!!Proprietary Income
    	    CAPITAL		!!Capital
    	    INDBUTAX	!!Indirect Business Taxes
    	!!Institutions
    	    HHLESS10K	!!Household earning less than 10K 
    	    HH10TO15K	!!Household earning 10-15K
    	    HH15TO25K	!!Household earning 15-25K
    	    HH25TO35K	!!Household earning 25-35K
    	    HH35TO50K 	!!Household earning 35-50K
    	    HH50TO75K  	!!Household earning 50-75K
    	    HH75TO100K	!!Household earning 75-100K
    	    HH100TO150K !!Household earning 100-150K
    	    HHMORE150K	!!Household earning more than 150K
    	    GOVFEDND   	!!Fed Gov Non-Defense
    	    GOVFEDDE	!!Fed Gov Defense
    	    GOVFEDINV   !!Fed Gov Investment
    	    GOVSTANE	!!State Gov Non-Education
    	    GOVSTAED	!!State Gov Education
    	    GOVSTAINV	!!State Gov Investment
    	    ENTERP		!!Enterprises
    	    INVEST		!!Gross Priv Fixed Investment
    	    INVENTORY	!!Inventory Sales Deletions
    	!!Trade Regions
    	    RoW			!!Trade with the rest of the world
    	    RoUS		!!Trade with the rest of the US
    	!!Major Land Resource Areas
    	    MLRA001
    	    MLRA002
            MLRA003
            MLRA005
            MLRA006
            MLRA007
            MLRA008
            MLRA009
            MLRA010
            MLRA011
            MLRA012
            MLRA014
            MLRA017
            MLRA018
            MLRA019
            MLRA020
            MLRA022
            MLRA023
            MLRA024
            MLRA025
            MLRA026
            MLRA028
            MLRA029
            MLRA030
            MLRA031
            MLRA032
            MLRA033
            MLRA034
            MLRA035
            MLRA036
            MLRA037
            MLRA038
            MLRA039
            MLRA040
            MLRA043
            MLRA044
            MLRA045
            MLRA046
            MLRA050
            MLRA051
            MLRA052
            MLRA053
            MLRA054
            MLRA059
            MLRA060
            MLRA061
            MLRA062
            MLRA063
            MLRA064
            MLRA065
            MLRA066
            MLRA067
            MLRA070
            MLRA071
            MLRA072
            MLRA073
            MLRA074
            MLRA075
            MLRA076
            MLRA077
            MLRA078
            MLRA079
            MLRA080
            MLRA081
            MLRA082
            MLRA083
            MLRA084
            MLRA085
            MLRA086
            MLRA088
            MLRA089
            MLRA090
            MLRA091
            MLRA092
            MLRA093
            MLRA095
            MLRA096
            MLRA097
            MLRA099
            MLRA100
            MLRA101
            MLRA104
            MLRA105
            MLRA106
            MLRA107
            MLRA108
            MLRA109
            MLRA111
            MLRA112
            MLRA113
            MLRA114
            MLRA115
            MLRA117
            MLRA118
            MLRA119
            MLRA121
            MLRA122
            MLRA123
            MLRA125
            MLRA126
            MLRA127
            MLRA130
            MLRA132
            MLRA133
            MLRA134
            MLRA135
            MLRA136
            MLRA137
            MLRA138
            MLRA140
            MLRA144
            MLRA145
            MLRA147
            MLRA148
            MLRA149
            MLRA150
            MLRA152
            MLRA153
            MLRA155
            MLRA156
            MLRA157
            MLRA159
            MLRA160
            MLRA161
            MLRA162
            MLRA163
            MLRA164
            MLRA165
            MLRA166
            MLRA167
            MLRA168
            MLRA169
            MLRA170
            MLRA172
            MLRA173
            MLRA174
            MLRA175
            MLRA176
            MLRA177
            MLRA178
            MLRA179
            MLRA181
            MLRA182
            MLRA184
            MLRA185
            MLRA186
            MLRA187
            MLRA188
            MLRA189
            MLRA191
            MLRA192
            MLRA193
            MLRA194
            MLRA195
            MLRA196
            MLRA197
            MLRA199
            MLRA200
            MLRA202
            MLRA203
            MLRA204
            MLRA205
            MLRA206
            MLRA207
            MLRA208
            MLRA210
            MLRA211
            MLRA212
            MLRA214
            MLRA215
            MLRA216
            MLRA217
            MLRA218
            MLRA219
            MLRA220
            MLRA221
            MLRA222
            MLRA223
            MLRA224
            MLRA225
            MLRA227
            MLRA228
            MLRA230
            MLRA231
            MLRA232
            MLRA233
            MLRA234
            MLRA235
            MLRA236
            MLRA238
            MLRA239
            MLRA240
            MLRA241
            MLRA242
            MLRA243
            MLRA244
            MLRA246
            MLRA247
            MLRA248
            MLRA249
            MLRA250
            MLRA252
            MLRA253
            MLRA254
            MLRA255
            MLRA256
            MLRA257
            MLRA258
            MLRA259
            MLRA260
       	    MLRA261
            MLRA262
            MLRA263
            MLRA264
            MLRA265
            MLRA266
            MLRA267
    	!!Taxes		
    		IMPTAX	Import taxes
    	!!Check Parameters
    	    TOTAL		Row and column totals
    	    DIFF		Difference between row and column totals
    	/;
    
    	SET MAP(K,Z) Mappping set to assign abbreviations to the IMPLAN codes /
    	!!Activities	
    		1.  Aolsd
    	    2.  Agran
    	    3.  Aoagr
    	    7.  Atobc
    	    8.  Acott
    	    9.  Asugr
    	    10. Aocrp
    	    11. Acatt
    	    12. Adair
    	    16. Afors
    	    20. Amini
    	    31. Autil
    	    34. Acons
    	    41. Amanf
    	    319.Awhol
    	    320.Aretl
    	    332.Atrns
    	    341.Ainfo
    	    354.Afinc
    	    360.Aland
    	    361.Aornt
    	    367.Aprof
    	    381.Amgmt
    	    382.Aadmw
    	    391.Aeduc
    	    394.Ahlth
    	    402.Aentt
    	    411.Ahotl
    	    414.Aoser
    	    427.Agven
    	    433.Auncl
    	    437.Agvem
    	!!Commodities
    	    3001.Colsd
    	    3002.Cgran
    	    3003.Coagr
    	    3007.Ctobc
    	    3008.Ccott
    	    3009.Csugr
    	    3010.Cocrp
    	    3011.Ccatt
    	    3012.Cdair
    	    3016.Cfors
    	    3020.Cmini
    	    3031.Cutil
    	    3034.Ccons
    	    3041.Cmanf
    	    3319.Cwhol
    	    3320.Cretl
    	    3332.Ctrns
    	    3341.Cinfo
    	    3354.Cfinc
    	    3360.Cland
    	    3361.Cornt
    	    3367.Cprof
    	    3381.Cmgmt
    	    3382.Cadmw
    	    3391.Ceduc
    	    3394.Chlth
    	    3402.Centt
    	    3411.Chotl
    	    3414.Coser
    	    3427.Cgven
    	    3433.Cuncl
    	    3437.Cgvem
    	!!Factors
    	    5001.LABOR	
    	    6001.PROPINC	
    	    7001.CAPITAL	
    	    8001.INDBUTAX
    	!!Institutions
    	    10001.HHLESS10K	
    	    10002.HH10TO15K	
    	    10003.HH15TO25K	
    	    10004.HH25TO35K	
    	    10005.HH35TO50K 	
    	    10006.HH50TO75K  	
    	    10007.HH75TO100K	
    	    10008.HH100TO150K 
    	    10009.HHMORE150K	
    	    11001.GOVFEDND   	
    	    11002.GOVFEDDE	
    	    11003.GOVFEDINV   
    	    12001.GOVSTANE	
    	    12002.GOVSTAED	
    	    12003.GOVSTAINV	
    	    13001.ENTERP		
    	    14001.INVEST		
    	    14002.INVENTORY	
    	!!Trade Regions
    	    25001.RoW
    	    28001.RoUS
    	!!Major Land Resource Areas
    	    MLRA001.MLRA001
    	    MLRA002.MLRA002
            MLRA003.MLRA003
            MLRA005.MLRA005
            MLRA006.MLRA006
            MLRA007.MLRA007
            MLRA008.MLRA008
            MLRA009.MLRA009
            MLRA010.MLRA010
            MLRA011.MLRA011
            MLRA012.MLRA012
            MLRA014.MLRA014
            MLRA017.MLRA017
            MLRA018.MLRA018
            MLRA019.MLRA019
            MLRA020.MLRA020
            MLRA022.MLRA022
            MLRA023.MLRA023
            MLRA024.MLRA024
            MLRA025.MLRA025
            MLRA026.MLRA026
            MLRA028.MLRA028
            MLRA029.MLRA029
            MLRA030.MLRA030
            MLRA031.MLRA031
            MLRA032.MLRA032
            MLRA033.MLRA033
            MLRA034.MLRA034
            MLRA035.MLRA035
            MLRA036.MLRA036
            MLRA037.MLRA037
            MLRA038.MLRA038
            MLRA039.MLRA039
            MLRA040.MLRA040
            MLRA043.MLRA043
            MLRA044.MLRA044
            MLRA045.MLRA045
            MLRA046.MLRA046
            MLRA050.MLRA050
            MLRA051.MLRA051
            MLRA052.MLRA052
            MLRA053.MLRA053
            MLRA054.MLRA054
            MLRA059.MLRA059
            MLRA060.MLRA060
            MLRA061.MLRA061
            MLRA062.MLRA062
            MLRA063.MLRA063
            MLRA064.MLRA064
            MLRA065.MLRA065
            MLRA066.MLRA066
            MLRA067.MLRA067
            MLRA070.MLRA070
            MLRA071.MLRA071
            MLRA072.MLRA072
            MLRA073.MLRA073
            MLRA074.MLRA074
            MLRA075.MLRA075
            MLRA076.MLRA076
            MLRA077.MLRA077
            MLRA078.MLRA078
            MLRA079.MLRA079
            MLRA080.MLRA080
            MLRA081.MLRA081
            MLRA082.MLRA082
            MLRA083.MLRA083
            MLRA084.MLRA084
            MLRA085.MLRA085
            MLRA086.MLRA086
            MLRA088.MLRA088
            MLRA089.MLRA089
            MLRA090.MLRA090
            MLRA091.MLRA091
            MLRA092.MLRA092
            MLRA093.MLRA093
            MLRA095.MLRA095
            MLRA096.MLRA096
            MLRA097.MLRA097
            MLRA099.MLRA099
            MLRA100.MLRA100
            MLRA101.MLRA101
            MLRA104.MLRA104
            MLRA105.MLRA105
            MLRA106.MLRA106
            MLRA107.MLRA107
            MLRA108.MLRA108
            MLRA109.MLRA109
            MLRA111.MLRA111
            MLRA112.MLRA112
            MLRA113.MLRA113
            MLRA114.MLRA114
            MLRA115.MLRA115
            MLRA117.MLRA117
            MLRA118.MLRA118
            MLRA119.MLRA119
            MLRA121.MLRA121
            MLRA122.MLRA122
            MLRA123.MLRA123
            MLRA125.MLRA125
            MLRA126.MLRA126
            MLRA127.MLRA127
            MLRA130.MLRA130
            MLRA132.MLRA132
            MLRA133.MLRA133
            MLRA134.MLRA134
            MLRA135.MLRA135
            MLRA136.MLRA136
            MLRA137.MLRA137
            MLRA138.MLRA138
            MLRA140.MLRA140
            MLRA144.MLRA144
            MLRA145.MLRA145
            MLRA147.MLRA147
            MLRA148.MLRA148
            MLRA149.MLRA149
            MLRA150.MLRA150
            MLRA152.MLRA152
            MLRA153.MLRA153
            MLRA155.MLRA155
            MLRA156.MLRA156
            MLRA157.MLRA157
            MLRA159.MLRA159
            MLRA160.MLRA160
            MLRA161.MLRA161
            MLRA162.MLRA162
            MLRA163.MLRA163
            MLRA164.MLRA164
            MLRA165.MLRA165
            MLRA166.MLRA166
            MLRA167.MLRA167
            MLRA168.MLRA168
            MLRA169.MLRA169
            MLRA170.MLRA170
            MLRA172.MLRA172
            MLRA173.MLRA173
            MLRA174.MLRA174
            MLRA175.MLRA175
            MLRA176.MLRA176
            MLRA177.MLRA177
            MLRA178.MLRA178
            MLRA179.MLRA179
            MLRA181.MLRA181
            MLRA182.MLRA182
            MLRA184.MLRA184
            MLRA185.MLRA185
            MLRA186.MLRA186
            MLRA187.MLRA187
            MLRA188.MLRA188
            MLRA189.MLRA189
            MLRA191.MLRA191
            MLRA192.MLRA192
            MLRA193.MLRA193
            MLRA194.MLRA194
            MLRA195.MLRA195
            MLRA196.MLRA196
            MLRA197.MLRA197
            MLRA199.MLRA199
            MLRA200.MLRA200
            MLRA202.MLRA202
            MLRA203.MLRA203
            MLRA204.MLRA204
            MLRA205.MLRA205
            MLRA206.MLRA206
            MLRA207.MLRA207
            MLRA208.MLRA208
            MLRA210.MLRA210
            MLRA211.MLRA211
            MLRA212.MLRA212
            MLRA214.MLRA214
            MLRA215.MLRA215
            MLRA216.MLRA216
            MLRA217.MLRA217
            MLRA218.MLRA218
            MLRA219.MLRA219
            MLRA220.MLRA220
            MLRA221.MLRA221
            MLRA222.MLRA222
            MLRA223.MLRA223
            MLRA224.MLRA224
            MLRA225.MLRA225
            MLRA227.MLRA227
            MLRA228.MLRA228
            MLRA230.MLRA230
            MLRA231.MLRA231
            MLRA232.MLRA232
            MLRA233.MLRA233
            MLRA234.MLRA234
            MLRA235.MLRA235
            MLRA236.MLRA236
            MLRA238.MLRA238
            MLRA239.MLRA239
            MLRA240.MLRA240
            MLRA241.MLRA241
            MLRA242.MLRA242
            MLRA243.MLRA243
            MLRA244.MLRA244
            MLRA246.MLRA246
            MLRA247.MLRA247
            MLRA248.MLRA248
            MLRA249.MLRA249
            MLRA250.MLRA250
            MLRA252.MLRA252
            MLRA253.MLRA253
            MLRA254.MLRA254
            MLRA255.MLRA255
            MLRA256.MLRA256
            MLRA257.MLRA257
            MLRA258.MLRA258
            MLRA259.MLRA259
            MLRA260.MLRA260
            MLRA261.MLRA261
            MLRA262.MLRA262
            MLRA263.MLRA263
            MLRA264.MLRA264
            MLRA265.MLRA265
            MLRA266.MLRA266
            MLRA267.MLRA267
    	!!Taxes		
    		IMPTAX .IMPTAX
    	!!Check Parameters	    
    	    TOTAL.TOTAL
    	    DIFF.DIFF
    	/;
    
    !!Declare the 8 subsets used to partition the SAM (including the MLRAs declared later on within the GDXIN command):
	SET AK(K) Activities /
		1		A-Oilseed           	
	    2	    A-Grain
	    3	    A-Other Agriculture
	    7	    A-Tobacco
	    8	    A-Cotton
	    9	    A-Sugar
	    10	    A-Other Crop
	    11	    A-Cattle Ranch
	    12	    A-Dairy
	    16	    A-Forestry
	    20	    A-Mining
	    31	    A-Utilities
	    34	    A-Construction
	    41	    A-Manufacturing
	    319	    A-Wholesale
	    320	    A-Retail
	    332	    A-Transp & Ware
	    341	    A-Information
	    354	    A-Finance
	    360	    A-Land Rent
	    361	    A-Other Rent
	    367	    A-Prof Sci Tech Serv
	    381	    A-Management
	    382	    A-Admin & Waste Serv
	    391	    A-Education
	    394	    A-Health
	    402	    A-Recreation
	    411	    A-Accom & Food Serv
	    414	    A-Other Serv
	    427	    A-Government
	    433		A-Unclassified
	    437		A-Gov Emp & Payroll	
		/;
         
	SET CK(K) Commodities /	
		3001	C-Oilseed 
	    3002	C-Grain                
	    3003	C-Other Agriculture            
	    3007	C-Tobacco              
	    3008	C-Cotton               
	    3009	C-Sugar                
	    3010	C-Other Crop           
	    3011	C-Cattle Ranch         
	    3012	C-Dairy                
	    3016	C-Forestry             
	    3020	C-Mining               
	    3031	C-Utilities            
	    3034	C-Construction         
	    3041	C-Manufacturing        
	    3319	C-Wholesale            
	    3320	C-Retail               
	    3332	C-Transp & Ware        
	    3341	C-Information          
	    3354	C-Finance              
	    3360	C-Land Rent            
	    3361	C-Other Rent           
	    3367	C-Prof Sci Tech Serv
	    3381	C-Management           
	    3382	C-Admin & Waste Serv   
	    3391	C-Education            
	    3394	C-Health               
	    3402	C-Recreation           
	    3411	C-Accom & Food Serv    
	    3414	C-Other Serv           
	    3427	C-Government           
		3433	C-Unclassified      
	    3437	C-Gov Emp & Payroll
		/;

	SET FK(K) New Value Added Accounts /
		5001	Labor
		6001	Proprietary Income
		7001	Capital
		8001	Indirect Business Taxes
		/;
         
	SET IK(K) Institutions /
		10001	Household 1
		10002	Household 2
		10003	Household 3
		10004	Household 4
		10005   Household 5
		10006   Household 6
		10007	Household 7
		10008   Household 8
		10009   Household 9
		11001   Fed Gov Non-Defense
		11002   Fed Gov Defense
		11003   Fed Gov Investment
		12001	State Gov Non-Education
		12002   State Gov Education
		12003   State Gov Investment
		13001   Enterprises
		14001   Gross Priv Fixed Investment
		14002   Inventory Sales Deletions
		/;

	SET TAXK(K) Taxes /	
		IMPTAX	Import taxes
		/;
		
	SET TK(K) Trade Regions  /
		25001	Rest of the world
		28001	Rest of the US
		/;

	SET TOTAL(K) Row and Column Totals /TOTAL/;

!!MAPPINGS
	!!One-to-one mapping of activities with commodities.
    !!IMPLAN does not follow this diagonal structure in the MAKE matrix. However, this mapping will be useful to
    !!model import duties per commodity and not per activity
    SET ACTCOM(AK,CK) One-to-one mapping of activities and commodities /
    	1  .3001	Oilseed 
    	2  .3002	Grain                    
    	3  .3003	Other Agriculture                
    	7  .3007	Tobacco                  
    	8  .3008	Cotton                   
    	9  .3009	Sugar                    
    	10 .3010	Other Crop               
    	11 .3011	Cattle Ranch             
    	12 .3012	Dairy                    
    	16 .3016	Forestry                 
    	20 .3020	Mining                   
    	31 .3031	Utilities                
    	34 .3034	Construction             
    	41 .3041	Manufacturing            
    	319.3319	Wholesale                
    	320.3320	Retail                   
    	332.3332	Transp & Ware            
    	341.3341	Information              
    	354.3354	Finance                  
    	360.3360	Land Rent                
    	361.3361	Other Rent               
    	367.3367	Prof Sci Tech Serv    
    	381.3381	Management               
    	382.3382	Admin & Waste Serv       
    	391.3391	Education                
    	394.3394	Health                   
    	402.3402	Recreation               
    	411.3411	Accom & Food Serv        
    	414.3414	Other Serv               
    	427.3427	Government               
    	433.3433	Unclassified      	
    	437.3437	Gov Emp & Payroll     
    /;
    
!!Aliasing the set K for the rows and columns of the SAM:
ALIAS (K,KK);

!!Inserting the DAT files from IMPLAN to create the BASIC SAM:
PARAMETER SAM(K,KK) Social Accounting Matrix /
$INCLUDE "%PATH%2x1.dat"
$INCLUDE "%PATH%3x1.dat"
$INCLUDE "%PATH%5x1.dat"
$INCLUDE "%PATH%1x2.dat"
$INCLUDE "%PATH%4x2.dat"
$INCLUDE "%PATH%4x3.dat"
$INCLUDE "%PATH%5x3.dat"
$INCLUDE "%PATH%2x4.dat"
$INCLUDE "%PATH%4x4.dat"
$INCLUDE "%PATH%5x4.dat"
$INCLUDE "%PATH%1x5.dat"
$INCLUDE "%PATH%4x5.dat"
$INCLUDE "%PATH%5x5.dat"
$INCLUDE "%PATH%4x6.dat"
$INCLUDE "%PATH%1x6.dat"
$INCLUDE "%PATH%6x1.dat"
$INCLUDE "%PATH%6x3.dat"
$INCLUDE "%PATH%6x4.dat"
/;

!!Reading the satellite tables to create the SATELLITE matrices
PARAMETER FEXPORT(K,KK)   Foreign commodity exports  /
$INCLUDE "%PATH%1x7.dat"
$INCLUDE "%PATH%4x7.dat"
/;

PARAMETER DEXPORT(K,KK)   Domestic commodity exports  /
$INCLUDE "%PATH%1x8.dat"
$INCLUDE "%PATH%4x8.dat"
/;

PARAMETER FIMPORT(K,KK)   Foreign commodity imports   /
$INCLUDE "%PATH%7x1.dat"
$INCLUDE "%PATH%7x4.dat"
/;

PARAMETER DIMPORT(K,KK)   Domestic commodity imports   /
$INCLUDE "%PATH%8x1.dat"
$INCLUDE "%PATH%8x4.dat"
/;

PARAMETER EMPLOY(*,AK)   Employment data for each activity /
$INCLUDE "%PATH%EMP.dat"
/;

!!Total amount of import duties from the GAMS file imported from IMPLAN under the option "Industry
!!detail SAM Files - GAMS single file". This GAMS file provides a matrix of payment and receipt
!!transactions between institutions including the transaction types.

PARAMETER TRANSACTION(*,*,*) Transaction figures /
$INCLUDE "%PATH%COMPLETE.gms"
/;

!!ADJUSTING COMMODITY TRADE

!!The satellite matrices obtained from IMPLAN represent trade as transactions between
!!activities and commodities from outside regions (rest of the US and the world).
!!However, when modeling the CGE, trade needs to be represented in the SAM as
!!transactions between commodities and outside regions. Hence, the transactions
!!obtained from the IMPLAN satellite matrices will be added to the MAKE and USE
!!submatrices and new accounts will be created for traded commodities.

	PARAMETER
		EXPORT(K,K,K)	Exports by sector - commodity - destination
		IMPORT(K,K,K)	Imports by commodity - sector - source;
		
	!!Checking exports:
		!!Adding exports from the RoUS and the RoW
		EXPORT(K,CK,"25001")	= FEXPORT(K,CK);
		EXPORT(K,CK,"28001")	= DEXPORT(K,CK);
		!!Adding activity and institutional exports to the activity and institutional MAKE matrices
		SAM(AK,CK)				= SAM(AK,CK) + SUM(TK,EXPORT(AK,CK,TK));
		SAM(IK,CK)				= SAM(IK,CK) + SUM(TK,EXPORT(IK,CK,TK));
		!!Assigning the export transactions to the commodity accounts
		SAM(CK,TK)				= SUM(K,EXPORT(K,CK,TK));
		!!Deleting the export transactions from the activity accounts
		SAM(AK,TK)				= 0;
		!!Estimating foreign transfers to domestic institutions
		SAM(IK,TK)				= SAM(IK,TK) - SUM(CK,EXPORT(IK,CK,TK));

	!!Checking imports:
		!!Adding imports from the RoUS and the RoW
		IMPORT(CK,K,"25001")	= FIMPORT(CK,K);
		IMPORT(CK,K,"28001")	= DIMPORT(CK,K);
		!!Adding activity and institutional imports to the activity and institutional USE matrices
		SAM(CK,AK)				= SAM(CK,AK) + SUM(TK,IMPORT(CK,AK,TK));
		SAM(CK,IK)				= SAM(CK,IK) + SUM(TK,IMPORT(CK,IK,TK));
		!!Assigning the import transactions to the commodity accounts
		SAM(TK,CK)				= SUM(K,IMPORT(CK,K,TK));
		!!Deleting the import transactions from the activity accounts
		SAM(TK,AK)				= 0;
		!!Estimating foreign transfers from domestic institutions
		SAM(TK,IK)				= SAM(TK,IK) - SUM(CK,IMPORT(CK,IK,TK)); 

	!!Netting transfers between factors, domestic institutions, the RoUS and RoW
		SAM(FK,TK)$(SAM(TK,FK) LT 0)		= SAM(FK,TK) - SAM(TK,FK);
		SAM(TK,FK)$(SAM(TK,FK) LT 0)		= 0;
		SAM(IK,TK)$(SAM(TK,IK) LT 0)		= SAM(IK,TK) - SAM(TK,IK);
		SAM(TK,IK)$(SAM(TK,IK) LT 0)		= 0;
		SAM(IK,TK)$(SAM(IK,TK) LT 0.0001)	= 0;

	!!Deleting any residuals in the Rest of the US (RoUS) trade accounts for the
	!!national aggregation
$IF %NATIONAL% == "NO" $GOTO ALABEL1
		SAM("28001",K) = 0;
		SAM(K,"28001") = 0;
$LABEL ALABEL1

!!ADJUSTING GOVERNMENT AND HOUSEHOLD TRANSFERS

!!There are some negative payments coming from low-income household categories to
!!the government. These are, essentially, transfers from the government to low-income
!!households. I will subtract these negative values from the regular government
!!transfers to households. There are also negative government transfers to the high-income
!!household categories. These are, essentially, taxes paid to the government. Hence,
!!I will substract these negative transfers to the tax payments coming from high-income
!!households to the government.

	SETS
		HK(IK) Households /10001*10009/
		GK(IK) Government /11001*11003,12001,12003/
		;
	
	!!Households negative payments to government ==> Government transfers to households
	SAM(HK,GK)$(SAM(GK,HK) LT 0)	= SAM(HK,GK) - SAM(GK,HK);
	SAM(GK,HK)$(SAM(GK,HK) LT 0)	= 0;
	
	!!Government negative payments to households ==> Households tax payments to government
	SAM(GK,HK)$(SAM(HK,GK) LT 0)	= SAM(GK,HK) - SAM(HK,GK);
	SAM(HK,GK)$(SAM(HK,GK) LT 0)	= 0;

!!SAM BALANCE PROCEDURE

!!To avoid any large and unreasonable changes in the Cross Entropy (CE) SAM balancing procedure, I took
!!some extra measurements to balance the SAM before pasing it through the CE method. The essential idea
!!is to get a balanced SAM by reducing the difference (DIFF) between the row and column sums for any account.
!!By using the trade, labor and indirect business taxes accounts; the following procedure assigns the 
!!small differences (DIFF) to "residual accounts" such as the investment and state government non-
!!education accounts.

	PARAMETERS
    	DIFF(K)		Differences between column and row sums
    	DIFF_CHK	Summation of the absolute values of differences between column and row sums. The closer to zero the better
    	SAM_CHK		Difference between the sum of row and column sums
		TOL			Tolerance /0.00000000001/
	;
    !!Creating the values that will fill the TOTAL and DIFF rows and colmuns of the extended SAM
	SAM("TOTAL",K)	= 0;
	SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
	SAM(K,"TOTAL") 	= 0;
	SAM(K,"TOTAL") 	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
    SAM("DIFF",K) 	= 0;
    SAM("DIFF",K) 	= SAM("TOTAL",K) - SAM(K,"TOTAL");
    DIFF(K)			= SAM("DIFF",K);

$IF %NATIONAL% == "YES" $GOTO ALABEL2
	!!Any difference (DIFF) left greater than the tolreance (TOL), between column and row sums, for any activity whose
	!!commodity has imports from the rest of the US (RoUS) account (28001) is passed to...
	SAM(AK,CK)$(ACTCOM(AK,CK) AND (ABS(DIFF(AK)) GT TOL) AND (SAM("28001",CK) GT 0) AND ((SAM(AK,CK)+DIFF(AK)) GT 0)) = SAM(AK,CK) + DIFF(AK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the imports from the RoUS (28001).
	SAM("28001",CK)$((ABS(DIFF(CK)) GT TOL) AND (SAM("28001",CK) GT 0) AND ((SAM("28001",CK)-DIFF(CK)) GT 0)) = SAM("28001",CK) - DIFF(CK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!For the activities whose commodities do not have imports from the RoUS, any DIFF greater than TOL is passed to...
	SAM(AK,CK)$(ACTCOM(AK,CK) AND (ABS(DIFF(CK)) GT TOL) AND (SAM("8001",AK) GT 0) AND ((SAM(AK,CK)-DIFF(CK)) GT 0)) = SAM(AK,CK) - DIFF(CK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the indirect business taxes (IBT) account (8001) of the corresponding activity, and then to...
	SAM("8001",AK)$((ABS(DIFF(AK)) GT TOL) AND (SAM("8001",AK) GT 0) AND ((SAM("8001",AK)-DIFF(AK)) GT 0)) = SAM("8001",AK) - DIFF(AK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the State Govt Non-education account (12001).
	SAM("12001","8001") = SAM("12001","8001") - DIFF("8001");
		SAM(K,"TOTAL") = 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K) = 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!Any DIFF greater than TOL left for any institution is passed to the transfers from the RoUS (28001), and then to...
	SAM("28001",IK)$((ABS(DIFF(IK)) GT TOL) AND (SAM("28001",IK) GT 0) AND ((SAM("28001",IK)-DIFF(IK)) GT 0)) = SAM("28001",IK) - DIFF(IK);
		SAM(K,"TOTAL") = 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K) = 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the investment account (14001) to make everything balance.
	SAM("14001","28001") = SAM("14001","28001") - DIFF("28001");
		SAM(K,"TOTAL") = 0;
		SAM(K,"TOTAL") = SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K) = 0;
		SAM("TOTAL",K) = SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
$LABEL ALABEL2

	!!Any difference (DIFF) left greater than the tolreance (TOL), between column and row sums, for any activity whose commodity
	!!has imports from the rest of the World (RoW) account (25001) is passed to...
	SAM(AK,CK)$(ACTCOM(AK,CK) AND (ABS(DIFF(AK)) GT TOL) AND (SAM("25001",CK) GT 0) AND ((SAM(AK,CK)+DIFF(AK)) GT 0)) = SAM(AK,CK) + DIFF(AK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the imports from the RoW (25001).
	SAM("25001",CK)$((ABS(DIFF(CK)) GT TOL) AND (SAM("25001",CK) GT 0) AND ((SAM("25001",CK)-DIFF(CK)) GT 0)) = SAM("25001",CK) - DIFF(CK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K) 	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!For the activities whose commodities do not have imports from the RoW, any DIFF greater than TOL is passed to...
	SAM(AK,CK)$(ACTCOM(AK,CK) AND (ABS(DIFF(CK)) GT TOL) AND (SAM("8001",AK) GT 0) AND ((SAM(AK,CK)-DIFF(CK)) GT 0)) = SAM(AK,CK) - DIFF(CK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the indirect business taxes (IBT) account (8001) of the corresponding activity.
	SAM("8001",AK)$((ABS(DIFF(AK)) GT TOL) AND (SAM("8001",AK) GT 0) AND ((SAM("8001",AK)-DIFF(AK)) GT 0)) = SAM("8001",AK) - DIFF(AK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!Here is where the balancing of the IBT (8001) takes place using the State Govt Non-education account (12001).
	SAM("12001","8001") = SAM("12001","8001") - DIFF("8001");
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!Any DIFF greater than TOL left for any institution is passed to the transfers from the RoW (25001).
	SAM("25001",IK)$((ABS(DIFF(IK)) GT TOL) AND (SAM("25001",IK) GT 0) AND ((SAM("25001",IK)-DIFF(IK)) GT 0)) = SAM("25001",IK) - DIFF(IK);
	!!Converting negative transfers from the RoUS and RoW to positive ones:
	SAM(IK,TK)$(SAM(TK,IK) LT 0) = SAM(IK,TK) - SAM(TK,IK);
	SAM(TK,IK)$(SAM(TK,IK) LT 0) = 0;
	SAM(TK,IK)$(SAM(IK,TK) LT 0) = SAM(TK,IK) - SAM(IK,TK);
	SAM(IK,TK)$(SAM(IK,TK) LT 0) = 0;
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!For the activities that do not pay IBT and whose commodities do not have imports from the RoW, any DIFF greater than TOL is passed to...
	SAM(AK,CK)$(ACTCOM(AK,CK) AND (ABS(DIFF(CK)) GT TOL)) = SAM(AK,CK) - DIFF(CK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the labor account (5001), and then it is passed to...
	SAM("5001",AK)$(ABS(DIFF(AK)) GT TOL) = SAM("5001",AK) - DIFF(AK);
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the RoW account, and then it is passed to...
	SAM("25001","5001")$(ABS(DIFF("5001")) GT TOL) = SAM("25001","5001") - DIFF("5001");
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);
	!!the investment account (14001) to make everything balance.
	SAM("14001","25001") = SAM("14001","25001") - DIFF("25001");
		SAM(K,"TOTAL")	= 0;
		SAM(K,"TOTAL")	= SAM(K,"TOTAL") + SUM(KK,SAM(K,KK));
		SAM("DIFF",K)	= 0;
		SAM("TOTAL",K)	= 0;
		SAM("TOTAL",K)	= SAM("TOTAL",K) + SUM(KK,SAM(KK,K));
		SAM("DIFF",K)	= SAM("TOTAL",K) - SAM(K,"TOTAL");
		DIFF(K)			= SAM("DIFF",K);

    DIFF_CHK = SUM(K,ABS(DIFF(K)));
    SAM_CHK = SUM(K,SAM("TOTAL",K)) - SUM(K,SAM(K,"TOTAL"));
	DISPLAY DIFF,DIFF_CHK,SAM_CHK;

!!EXPORTING THE SAM
	!!Total number of accounts in the SAM exported to the GDX file:
    SETS
    	ALLACCTS(K)	all accounts including row totals
    	ACCTS(K) 	accounts not including row totals
    ;
    ALLACCTS(K)$(SAM("TOTAL",K) NE 0) = AK(K) + CK(K) + IK(K) + FK(K) + TK(K) + TOTAL(K);
    ACCTS(K)$(SAM("TOTAL",K) NE 0) = AK(K) + CK(K) + IK(K) + FK(K) + TK(K);
    
    !!This is the EXECUTE command to create the GDX file
    EXECUTE_UNLOAD "unbalsam.gdx",SAM,REGION,ALLACCTS,ACCTS,K,AK,CK,FK,IK,TAXK,TK,Y,STATE,AGG,IMPLAN,Z,MAP,ACTCOM,EMPLOY,TRANSACTION;
*/
